;FILE	:FINDNEXT.ASM
;USEAGE	:call findnext(ret%)
;RET% is TRUE (-1) if another file was found, FALSE(0) if not.
;FINDNEXT finds another file that fits the FINDFILE description, if it can.

findnext segment
assume	cs:findnext
	push	bp		;Standard stuff.
	mov	bp,sp
	mov	ah,04fh		;FINDNEXT spec.
	xor	cx,cx		;Return word. (set to false)
	int	021h		;MSDOS! Returns carry set if no file.
	jc	noerr		;No error! let's set it true.
	dec	cx
noerr:	les	di,[bp+06h]	;address of integer variable
	mov	es:[di],cx	;Move result code.
	pop	bp		;Restore BP
findnext ends
	end
	
